PostgreSQL: Important temBoard Agent Update Version 7.4

  • Post author:
  • Post category:PostgreSQL

Dalibo released yesterday a new version of the temBoard Agent (Version 7.4) It fixes the following error, which was introduced with temBoard Agent (Version 7.3).

2020-11-19 06:19:49,376 temboardagent[531]: [taskmanager] ERROR: <class 'TypeError'>: Object of type 'datetime' is not JSON serializable
2020-11-19 06:19:49,376 temboardagent[531]: [taskmanager] ERROR: Traceback (most recent call last):
2020-11-19 06:19:49,376 temboardagent[531]: [taskmanager] ERROR:   File "/usr/lib/python3.6/site-packages/temboardagent/toolkit/taskmanager.py", line 882, in exec_worker
2020-11-19 06:19:49,376 temboardagent[531]: [taskmanager] ERROR:     res = getattr(sys.modules[module], function)(*args, **kws)
2020-11-19 06:19:49,376 temboardagent[531]: [taskmanager] ERROR:   File "/usr/lib/python3.6/site-packages/temboardagent/toolkit/taskmanager.py", line 1046, in wrapper
2020-11-19 06:19:49,376 temboardagent[531]: [taskmanager] ERROR:     return function(app=self.app, *a, **kw)
2020-11-19 06:19:49,376 temboardagent[531]: [taskmanager] ERROR:   File "/usr/lib/python3.6/site-packages/temboardagent/plugins/monitoring/__init__.py", line 270, in monitoring_collector_worker
2020-11-19 06:19:49,376 temboardagent[531]: [taskmanager] ERROR:     output
2020-11-19 06:19:49,376 temboardagent[531]: [taskmanager] ERROR:   File "/usr/lib/python3.6/site-packages/temboardagent/plugins/monitoring/db.py", line 49, in add_metric
2020-11-19 06:19:49,376 temboardagent[531]: [taskmanager] ERROR:     (time, json.dumps(data))
2020-11-19 06:19:49,376 temboardagent[531]: [taskmanager] ERROR:   File "/usr/lib64/python3.6/json/__init__.py", line 231, in dumps
2020-11-19 06:19:49,376 temboardagent[531]: [taskmanager] ERROR:     return _default_encoder.encode(obj)
2020-11-19 06:19:49,376 temboardagent[531]: [taskmanager] ERROR:   File "/usr/lib64/python3.6/json/encoder.py", line 199, in encode
2020-11-19 06:19:49,376 temboardagent[531]: [taskmanager] ERROR:     chunks = self.iterencode(o, _one_shot=True)
2020-11-19 06:19:49,376 temboardagent[531]: [taskmanager] ERROR:   File "/usr/lib64/python3.6/json/encoder.py", line 257, in iterencode
2020-11-19 06:19:49,376 temboardagent[531]: [taskmanager] ERROR:     return _iterencode(o, 0)
2020-11-19 06:19:49,376 temboardagent[531]: [taskmanager] ERROR:   File "/usr/lib64/python3.6/json/encoder.py", line 180, in default
2020-11-19 06:19:49,376 temboardagent[531]: [taskmanager] ERROR:     o.__class__.__name__)
2020-11-19 06:19:49,376 temboardagent[531]: [taskmanager] ERROR: TypeError: Object of type 'datetime' is not JSON serializable

The issue with that error is that some metrics are not gathered correctly, for example the Instance size, which is quite important from my point of view. In the following graph you can see it clearly that during the time when the agent 7.3 was running, the Instance size metric was not gathered. After upgrading the agent to 7.4 it worked correctly again.

 

To fix this issue, just grep the temBoard agent 7.4 (temboard-agent-7.4-1.el7.noarch.rpm) from the following link and apply it with yum afterwards.

In case you are on CentOS 7, use this one

https://yum.dalibo.org/labs/CentOS7-x86_64/

In case you are on CentOS 8, use this one

https://yum.dalibo.org/labs/CentOS8-x86_64/

Now stop all agents that are running on your host.

$ systemctl -l | grep temboard | grep -v system- | awk '{ print $1 }' | while read i
   do
     sudo systemctl stop $i
   done

The update of the temBoard agent is very easy. Just run the yum update/localupdate depending of how you installed it. Depending on your installation, it might install automatically some python3-libs as well.

$ sudo yum -y localupdate temboard-agent-7.4-1.el7.noarch.rpm
Loaded plugins: enabled_repos_upload, langpacks, package_upload, product-id, search-disabled-repos, subscription-manager
Examining temboard-agent-7.4-1.el7.noarch.rpm: temboard-agent-7.4-1.el7.noarch
Marking temboard-agent-7.4-1.el7.noarch.rpm as an update to temboard-agent-7.0-1.el7.noarch
Resolving Dependencies
--> Running transaction check
---> Package temboard-agent.noarch 0:7.0-1.el7 will be updated
---> Package temboard-agent.noarch 0:7.4-1.el7 will be an update
--> Processing Dependency: python(abi) = 3.6 for package: temboard-agent-7.4-1.el7.noarch
epel/x86_64/metalink                                                                                                                           |  29 kB  00:00:00
epel                                                                                                                                           | 4.7 kB  00:00:00
rhel-7-server-extras-rpms                                                                                                                      | 2.0 kB  00:00:00
rhel-7-server-optional-rpms                                                                                                                    | 2.0 kB  00:00:00
rhel-7-server-rh-common-rpms                                                                                                                   | 2.1 kB  00:00:00
rhel-7-server-rpms                                                                                                                             | 2.0 kB  00:00:00
rhel-7-server-satellite-tools-6.7-rpms                                                                                                         | 2.1 kB  00:00:00
rhel-7-server-supplementary-rpms                                                                                                               | 2.3 kB  00:00:00
rhel-server-rhscl-7-rpms                                                                                                                       | 2.3 kB  00:00:00
(1/2): epel/x86_64/updateinfo                                                                                                                  | 1.0 MB  00:00:00
(2/2): epel/x86_64/primary_db                                                                                                                  | 6.9 MB  00:00:00
--> Processing Dependency: /usr/bin/python3 for package: temboard-agent-7.4-1.el7.noarch
--> Processing Dependency: python3-psycopg2 for package: temboard-agent-7.4-1.el7.noarch
--> Processing Dependency: python3-setuptools for package: temboard-agent-7.4-1.el7.noarch
--> Running transaction check
---> Package python3.x86_64 0:3.6.8-13.el7 will be installed
--> Processing Dependency: python3-libs(x86-64) = 3.6.8-13.el7 for package: python3-3.6.8-13.el7.x86_64
--> Processing Dependency: python3-pip for package: python3-3.6.8-13.el7.x86_64
--> Processing Dependency: libpython3.6m.so.1.0()(64bit) for package: python3-3.6.8-13.el7.x86_64
---> Package python3-psycopg2.x86_64 0:2.7.7-2.el7 will be installed
---> Package python3-setuptools.noarch 0:39.2.0-10.el7 will be installed
--> Running transaction check
---> Package python3-libs.x86_64 0:3.6.8-13.el7 will be installed
---> Package python3-pip.noarch 0:9.0.3-7.el7_8 will be installed
--> Finished Dependency Resolution

Dependencies Resolved

======================================================================================================================================================================
 Package                                 Arch                        Version                              Repository                                             Size
======================================================================================================================================================================
Updating:
 temboard-agent                          noarch                      7.4-1.el7                            /temboard-agent-7.4-1.el7.noarch                      945 k
Installing for dependencies:
 python3                                 x86_64                      3.6.8-13.el7                         rhel-7-server-rpms                                     69 k
 python3-libs                            x86_64                      3.6.8-13.el7                         rhel-7-server-rpms                                    7.0 M
 python3-pip                             noarch                      9.0.3-7.el7_8                        rhel-7-server-rpms                                    1.8 M
 python3-psycopg2                        x86_64                      2.7.7-2.el7                          epel                                                  157 k
 python3-setuptools                      noarch                      39.2.0-10.el7                        rhel-7-server-rpms                                    629 k

Transaction Summary
======================================================================================================================================================================
Install             ( 5 Dependent packages)
Upgrade  1 Package

Total size: 10 M
Total download size: 9.6 M
Downloading packages:
(1/5): python3-3.6.8-13.el7.x86_64.rpm                                                                                                         |  69 kB  00:00:00
(2/5): python3-libs-3.6.8-13.el7.x86_64.rpm                                                                                                    | 7.0 MB  00:00:00
(3/5): python3-pip-9.0.3-7.el7_8.noarch.rpm                                                                                                    | 1.8 MB  00:00:00
(4/5): python3-setuptools-39.2.0-10.el7.noarch.rpm                                                                                             | 629 kB  00:00:00
(5/5): python3-psycopg2-2.7.7-2.el7.x86_64.rpm                                                                                                 | 157 kB  00:00:00
----------------------------------------------------------------------------------------------------------------------------------------------------------------------
Total                                                                                                                                  17 MB/s | 9.6 MB  00:00:00
Running transaction check
Running transaction test
Transaction test succeeded
Running transaction
  Installing : python3-libs-3.6.8-13.el7.x86_64                                                                                                                   1/7
  Installing : python3-3.6.8-13.el7.x86_64                                                                                                                        2/7
  Installing : python3-setuptools-39.2.0-10.el7.noarch                                                                                                            3/7
  Installing : python3-pip-9.0.3-7.el7_8.noarch                                                                                                                   4/7
  Installing : python3-psycopg2-2.7.7-2.el7.x86_64                                                                                                                5/7
  Updating   : temboard-agent-7.4-1.el7.noarch                                                                                                                    6/7
You must restart manually temboard-agent services.
  Cleanup    : temboard-agent-7.0-1.el7.noarch                                                                                                                    7/7
Uploading Package Profile
Loaded plugins: langpacks, product-id, subscription-manager
  Verifying  : python3-psycopg2-2.7.7-2.el7.x86_64                                                                                                                1/7
  Verifying  : temboard-agent-7.4-1.el7.noarch                                                                                                                    2/7
  Verifying  : python3-setuptools-39.2.0-10.el7.noarch                                                                                                            3/7
  Verifying  : python3-3.6.8-13.el7.x86_64                                                                                                                        4/7
  Verifying  : python3-libs-3.6.8-13.el7.x86_64                                                                                                                   5/7
  Verifying  : python3-pip-9.0.3-7.el7_8.noarch                                                                                                                   6/7
  Verifying  : temboard-agent-7.0-1.el7.noarch                                                                                                                    7/7

Dependency Installed:
  python3.x86_64 0:3.6.8-13.el7                python3-libs.x86_64 0:3.6.8-13.el7    python3-pip.noarch 0:9.0.3-7.el7_8    python3-psycopg2.x86_64 0:2.7.7-2.el7
  python3-setuptools.noarch 0:39.2.0-10.el7

Updated:
  temboard-agent.noarch 0:7.4-1.el7

Complete!
Uploading Enabled Repositories Report
Loaded plugins: langpacks, product-id, subscription-manager

Check if the package was updated successfully.

$ rpm -qa | grep temboard
temboard-agent-7.4-1.el7.noarch

After the update is done, start/restart the agents.

$./restart-agents.sh
INFO: Running systemctl reset-failed and daemon-reload
running
INFO: Search for temboard-agent files in the /etc/systemd/ directory
/etc/systemd/system/multi-user.target.wants/temboard-agent@12-pg55011.service
/etc/systemd/system/multi-user.target.wants/temboard-agent@12-pg55012.service
/etc/systemd/system/multi-user.target.wants/temboard-agent@12-pg55013.service
/etc/systemd/system/multi-user.target.wants/temboard-agent@12-pg55014.service
INFO: Restarting temboard-agent@12-pg55011.service
INFO: Restarting temboard-agent@12-pg55012.service
INFO: Restarting temboard-agent@12-pg55013.service
INFO: Restarting temboard-agent@12-pg55014.service

This is the script I use for doing that.

$ cat restart-agents.sh
#!/bin/bash -eu
#------------------------------------------------------------------------------------------------------------------------#
#-- Author: William
#--
#-- Purpose: Restart temBoard Agents
#--
#-- Debugging

# set -x

#------------------------------------------------------------------------------------------------------------------------#


if ! hash sudo systemctl &>/dev/null; then
        echo "ERROR: You must restart manually temboard-agent services" >&2
        exit 0
fi

echo "INFO: Running systemctl reset-failed and daemon-reload"
sudo systemctl reset-failed
sudo systemctl daemon-reload
sudo systemctl is-system-running

if ! sudo systemctl is-system-running &>/dev/null ; then
        echo "ERROR: You must restart manually temboard-agent services" >&2
        echo "ERROR: Check with sudo systemctl list-units --state=failed"
        echo "ERROR: Correct it, and run afterwards sudo systemctl reset-failed"
        exit 0
fi


#------------------------------------------------------------------------------------------------------------------------#

prefix=temboard-agent@

# search for files in the /etc/systemd/ directory

echo "INFO: Search for temboard-agent files in the /etc/systemd/ directory"
sudo find /etc/systemd/system/multi-user.target.wants/ -name "${prefix}*"

active_units="$(sudo systemctl --all --plain list-units ${prefix}* | grep -Po ${prefix}.*\\.service ||:)"

if [ -z "${active_units}" ] ; then
        echo "ERROR: No units found for temboard-agent" >&2
        exit 0;
fi

exit_code=0
for unit in ${active_units} ; do
        echo "INFO: Restarting $unit" >&2
        sudo systemctl stop $unit
        sleep 3
        sudo systemctl start $unit
        # if ! sudo systemctl restart $unit ; then
        #               echo "ERROR: Failed to restart $unit" >&2
        #       exit_code=1
        # fi
done

exit $exit_code

#------------------------------------------------------------------------------------------------------------------------#

Ready.

Conclusion

The temBoard monitoring tool is very cool software and easy to install. Thanks to Dalibo for sharing that with the community. Whenever you might face an issue with temBoard, they usually fix it very quickly.